from random import randint
from time import sleep

class FSM():
	def __init__(self, baseState):
		#Set a default state.
		self.state = baseState
		print("Initial state: State " + str(self.state))

	def transition(self, state):
		print("Transitioning")
		if(state == 0):
			self.state0()
		elif(state == 1):
			self.state1()
		else:
			self.state2()

	def state0(self):
		print("State 0")

	def state1(self):
		print("State 1")

	def state2(self):
		print("State 2")

if __name__ == '__main__':
	print("Initializing State Machine")
	state_machine = FSM(0)

	#Initialize FSM for 20 seconds.
	for i in range(0, 20):
		#Drag a random integer.
		rnd = randint(0,2)
		#Wait 1 second before making the transition.
		sleep(1)
		#The transition change will be based on the random input.
		state_machine.transition(rnd)